#!/bin/bash

# Copyright (C) 2011-2013 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR
#
# This file is part of le-dosvox
#
# le-dosvox is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.

# Function which fix dosvox issues on wine
function configureDosvox () {
    VAR1="Lucida Console"
    VAR2="Droid Sans Mono"
    VAR3="LARGURALETRA="
    VAR4="ALTURALETRA="
    VAR5="/home/dosvox_user"
    DESKTOP="Área de Trabalho"
    sed -e "s/${VAR1}/${VAR2}/" -e "s/${VAR3}/${VAR3}12/" \
        -e "s/${VAR4}/${VAR4}29/" \
        -i /home/$1/.wine/drive_c/winvox/dosvox.ini
    cp "/home/$1/$DESKTOP/Dosvox.desktop" /home/$1
    mv "/home/$1/$DESKTOP/Dosvox.lnk" "/home/$1/$DESKTOP/.Dosvox.lnk"
    sed -i "s\/${1}/\/dosvox_user/\ " /home/$USER_TO_INSTALL/Dosvox.desktop
    cp /home/$1/.wine/drive_c/winvox/dosvox.ini \
        /home/$1/.wine/drive_c/windows/dosvox.ini
    mkdir $VAR5/Área\ de\ Trabalho
    cp /home/$1/Dosvox.desktop "$VAR5/$DESKTOP"
    cp -R /home/$1/.wine $VAR5
    cp/home/$1/.local/share/icons/hicolor/32x32/apps/150E_dosvox.0.png \
        $VAR5/.local/share/icons/hicolor/32x32/apps
    chown -Rf dosvox_user:dosvox_user $VAR5/.wine
    chown dosvox_user:dosvox_user "$VAR5/$DESKTOP/Dosvox.desktop" 

}

# Main

USER_TO_INSTALL=$1

# Verifies if $USER_TO_INSTALL holds something
if [[ "$USER_TO_INSTALL" = "" ]]; then
    gksudo "/usr/bin/install-dosvox.sh $USER"
    exit 0

elif [[ "$(grep $USER_TO_INSTALL /etc/passwd)" = "" ]]; then
    zenity --error --title="Erro ao instalar" \
        --text="O usuário não pode ser indentificado"
    exit 1
fi

# Info message about installation process
zenity --info --title="Instalação do dosvox no linux educacional 5" \
--text="Esse programa vai auxiliar-te na instalação do dosvox no linux \
educacional 5.
O dosvox é um programa desenvolvido e mantido pelo Núcleo de Computação \
Eletronica da UFRJ, cujo o site oficial é:

http://intervox.nce.ufrj.br/dosvox/"

# Begin installation
EXITCODE=0

# Download dosvox installer into /tmp
(wget --progress=bar:force -O /tmp/dv45-setup.exe \
"http://intervox.nce.ufrj.br/dosvox/programas/dv45-setup.exe" 2>&1 \
| zenity --title="Baixando o Dosvox" --text="Por favor aguarde"\
    --progress --auto-close --auto-kill)

EXITCODE=$?
if [[ "$EXITCODE" != "0" ]]; then
    kill -15 $(pidof zenity)
    zenity --error --title="Download Dosvox" \
        --text="Houve um problema no download do dosvox, tente novamente \
mais tarde"
    exit 1
fi

# Create new user to use dosvox
useradd -m -s /bin/bash dosvox_user
passwd -d dosvox_user

# Install dosvox
zenity --info --title="ATENÇÃO" \
    --text="Ao final da instalação, o dosvox vai iniciar automaticamente. \
Porém ele ainda não foi configurado, e tu terás que fechar o dosvox \
usando  Alt F4. Assim, o esse programa poderá configurar certos aspectos \
do dosvox."
gksudo -u $USER_TO_INSTALL "wine /home/$USER_TO_INSTALL/le-dosvox/dv45-setup.exe"

# Modify some lines on dosvox configuration file
configureDosvox $USER_TO_INSTALL | zenity --progress --pulsate \
    --text="Completando a instalação, por favor aguarde" --title="Terminando a instalação"

# Displays mensage saying the installation is completed
zenity --info --title="Instalação completa" --text="O Dosvox foi instalado \
nesse computador. Para usa-lo, basta \"logar\" no sistema como o usuário \
dosvox_user e iniciar o programa pelo atalho que está na área de trabalho."
